#!/usr/local/bin/perl5

package conf;
use Exporter;
use vars qw( @ISA @EXPORT );
@ISA = qw(Exporter);
@EXPORT = qw(
	     $libDir
	     $etcDir
	     $logDir
	     $logFile
	     $debug
	     $maxMessageLength
	     $maxNickLength
	     $maxHostLen
	     $maxTopicLen
	     $maxProtocol
	     $protoDefaultLines
	     $clientPort
	     $managerPort
	     $PROTOCOL
	     );

$libDir = "/usr/local/lib/vchat";
$etcDir = "/usr/local/etc/vchat";
$logDir = "/var/log";

$logFile = $logDir . "/chatserver.log";

$debug = 0;
$maxMessageLength = 1024;	# max. length of messages accepted by
				# clients.  Excess bytes are cut off
				# by the server.
$maxNickLength = 20;		# max. length of a nickname
$maxHostLen = 30;		# maximum length of a host name
$maxTopicLen = 60;		# maximum length of a channel topic
$maxProtocol = 2000;		# Number of chat protocol lines to be
				# kept in-core.
$protoDefaultLines = 20;	# default number of lines to show with
				# '.p' command

$clientPort = 2323;		# clients connect to this port
$managerPort = 2324;		# manager capabilities are available
				# here

$PROTOCOL = new FileHandle(">$logFile");

$PROTOCOL or die "$0: could not open log file $logFile: $!\n";

autoflush $PROTOCOL 1;


1;
